﻿using System;

namespace AC.Input.Platforms.Linux
{
	internal static class X11Helper
	{				
		#region ConvertX11ToKeys
		public static Keys ConvertX11ToKeys(uint x11keycode)
		{
			switch (x11keycode)
			{
				case 32:
					return Keys.Space;
				//case 65509:
				//  return Keys.CAPITAL;
				case 65289:
					return Keys.Tab;
				case 65106:
					return Keys.OEM102;// == ^ ° (ger)
				//case 65366:
				//  return Keys.PGDOWN;
				//case 65365:
				//  return Keys.PGUP;
				case 65363:
					return Keys.Right;
				case 65361:
					return Keys.Left;
				case 65364:
					return Keys.Down;
				case 65362:
					return Keys.Up;

				// 65293 is return, 65421 is numpad-return.
				case 65293:
				case 65421:
					return Keys.Return;

				case 65451:
					return Keys.Add;
				case 65300:
					return Keys.ScrollLock;
				case 65299:
					return Keys.Pause;
				case 65367:
					return Keys.End;
				case 65360:
					return Keys.Home;
				case 65535:
					return Keys.Delete;
				case 65379:
					return Keys.Insert;
				case 65377:
					return Keys.Noname;
				case 65453:
					return Keys.Subtract;
				case 65450:
					return Keys.Multiply;
				case 65455:
					return Keys.Divide;
				case 65407:
					return Keys.NumLock;
				case 65434:
					return Keys.Numpad9;
				case 65431:
					return Keys.Numpad8;
				case 65429:
					return Keys.Numpad7;
				case 65432:
					return Keys.Numpad6;
				case 65437:
					return Keys.Numpad5;
				case 65430:
					return Keys.Numpad4;
				case 65435:
					return Keys.Numpad3;
				case 65433:
					return Keys.Numpad2;
				case 65438:
					return Keys.Numpad0;
				case 65436:
					return Keys.Numpad1;
				case 65470:
					return Keys.F1;
				case 65471:
					return Keys.F2;
				case 65472:
					return Keys.F3;
				case 65473:
					return Keys.F4;
				case 65474:
					return Keys.F5;
				case 65475:
					return Keys.F6;
				case 65476:
					return Keys.F7;
				case 65477:
					return Keys.F8;
				case 65478:
					return Keys.F9;
				case 65479:
					return Keys.F10;
				case 65480:
					return Keys.F11;
				case 65481:
					return Keys.F12;
				case 65105:
					return Keys.OEM6;// == ` ' (ger)
				case 223:
					return Keys.OEM1;// == ? ß \ (ger)
				case 48:
					return Keys.N0;
				case 49:
					return Keys.N1;
				case 50:
					return Keys.N2;
				case 51:
					return Keys.N3;
				case 52:
					return Keys.N4;
				case 53:
					return Keys.N5;
				case 54:
					return Keys.N6;
				case 55:
					return Keys.N7;
				case 56:
					return Keys.N8;
				case 57:
					return Keys.N9;
				case 65513:
					return Keys.LeftMenu;
				case 65383:
					return Keys.RightWindows;
				case 65515:
					return Keys.LeftWindows;
				case 65507:
					return Keys.LeftControl;
				case 65506:
					return Keys.RightShift;
				case 65505:
					return Keys.LeftShift;
				case 65307:
					return Keys.Escape;
				case 119:
					return Keys.W;
				case 101:
					return Keys.E;
				case 114:
					return Keys.R;
				case 116:
					return Keys.T;
				case 122:
					return Keys.Z;
				case 117:
					return Keys.U;
				case 105:
					return Keys.I;
				case 111:
					return Keys.O;
				case 112:
					return Keys.P;
				case 97:
					return Keys.A;
				case 115:
					return Keys.S;
				case 100:
					return Keys.D;
				case 102:
					return Keys.F;
				case 103:
					return Keys.G;
				case 104:
					return Keys.H;
				case 106:
					return Keys.J;
				case 107:
					return Keys.K;
				case 108:
					return Keys.L;
				case 121:
					return Keys.Y;
				case 120:
					return Keys.X;
				case 99:
					return Keys.C;
				case 118:
					return Keys.V;
				case 98:
					return Keys.B;
				case 110:
					return Keys.N;
				case 109:
					return Keys.M;
				case 113:
					return Keys.Q;
				default:
					return Keys.Noname;
			}
		}
		#endregion
	}
}
